// HypervisorException.cpp

#include "StdAfx.h"
#include "HypervisorException.h"


CHypervisorException::CHypervisorException():
    m_WinErrorCode(NO_ERROR)
{
}

CHypervisorException::CHypervisorException(const char *pErrorText, DWORD errorCode):
    std::exception(pErrorText),
    m_WinErrorCode(errorCode)
{
}

CHypervisorException::CHypervisorException(const CAtlException &e):
    std::exception("COM error"),
    m_WinErrorCode((HRESULT)e)
{
}

CString CHypervisorException::GetWinMessage() const
{
    TCHAR buffer[1024];

    if (::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 
                        NULL, 
                        m_WinErrorCode, 
                        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), 
                        buffer,
                        _countof(buffer),
                        NULL) != 0)
    {
        return buffer;
    }
    return L"Unknown error.";
}
