// Interfaces.h

#pragma once


class IVirtualMachine
{
public:
    virtual ~IVirtualMachine() {}

    virtual CStringW GetID() = 0;
    virtual CStringW GetName() = 0;

    virtual bool IsRunning() = 0;
    virtual void Start() = 0;
    virtual void Stop() = 0;
    virtual void Shutdown() = 0;

    virtual CStringW GetDnsName() = 0;
    virtual CStringW GetIPv4Addr() = 0;
};

class IEnumVirtualMachines
{
public:
    virtual ~IEnumVirtualMachines() {}

    virtual bool NextID(CStringW &vmID) = 0;
    virtual void Reset() = 0;
};

class IHypervisor
{
public:
    virtual ~IHypervisor() {}

    virtual void Connect(
        PCWSTR pServer,
        PCWSTR pDomain   = NULL,
        PCWSTR pUser     = NULL,
        PCWSTR pPassword = NULL) = 0;

    virtual void Disconnect() = 0;

    virtual IVirtualMachine* GetVirtualMachine(PCWSTR pVmID) = 0;

    virtual IEnumVirtualMachines* EnumVirtualMachines() = 0;
};
